var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Base2N = require('@navpreetdevpuri/base-2-n');
function sortEncryptedFields(schema, options) {
    var _a;
    var _b = options.noOfDividePartsForSearching, noOfDividePartsForSearching = _b === void 0 ? 100 : _b, _c = options.noOfCharsToIncreaseOnSaturation, noOfCharsToIncreaseOnSaturation = _c === void 0 ? 2 : _c;
    options.noOfDividePartsForSearching = noOfDividePartsForSearching;
    options.noOfCharsToIncreaseOnSaturation = noOfCharsToIncreaseOnSaturation;
    var sortFields = {};
    var decrypters = {};
    function documentsBinarySearch(documents, fieldName, value) {
        var start = 0;
        var end = documents.length - 1;
        while (start <= end) {
            var mid = Math.floor((start + end) / 2);
            var decryptedMidValue = decrypters[fieldName](documents[mid][fieldName]).toLowerCase();
            if (value < decryptedMidValue) {
                end = mid - 1;
            }
            else if (decryptedMidValue <= value) {
                start = mid + 1;
            }
        }
        return start;
    }
    function getAverageSortId(predecessorSortId, successorSortId) {
        if (!predecessorSortId) {
            predecessorSortId = ''.padEnd(successorSortId.length, '\0');
        }
        if (!successorSortId) {
            successorSortId = ''.padEnd(predecessorSortId.length, '\uffff');
        }
        var predecessorNumber;
        var successorNumber;
        if (predecessorSortId.length == predecessorSortId.length) {
            predecessorNumber = new Base2N(predecessorSortId);
            successorNumber = new Base2N(successorSortId);
            var averageNumber = predecessorNumber.average(successorNumber);
            if (averageNumber.toString() != predecessorNumber.toString()) {
                return averageNumber.toString();
            }
            predecessorNumber = new Base2N(predecessorSortId.padEnd(averageNumber.length + noOfCharsToIncreaseOnSaturation, '\0'));
            successorNumber = new Base2N(successorSortId.padEnd(averageNumber.length + noOfCharsToIncreaseOnSaturation, '\0'));
            return predecessorNumber.average(successorNumber).toString();
        }
        var bigger = predecessorSortId.length > successorSortId.length
            ? predecessorSortId
            : successorSortId;
        var smaller = successorSortId.length > predecessorSortId.length
            ? predecessorSortId
            : successorSortId;
        var biggerNumber = new Base2N(bigger);
        var smallerNumber = new Base2N(smaller.padEnd(bigger.length, '\0'));
        return biggerNumber.average(smallerNumber).toString();
    }
    function getMatchForAggregate(documents, fieldName, fieldValue, sortFieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var index, gteIndex, lteIndex, match;
            var _a, _b;
            return __generator(this, function (_c) {
                index = documentsBinarySearch(documents, fieldName, fieldValue);
                gteIndex = index - 1;
                lteIndex = index;
                match = {
                    $and: [
                        (_a = {}, _a[sortFieldName] = { $ne: null }, _a),
                        (_b = {},
                            _b[sortFieldName] = {
                                $gte: gteIndex == -1 ? undefined : documents[gteIndex][sortFieldName],
                                $lte: lteIndex == documents.length
                                    ? undefined
                                    : documents[lteIndex][sortFieldName],
                            },
                            _b),
                    ],
                };
                return [2 /*return*/, match];
            });
        });
    }
    function updateSortFieldsForDocument(objectId, model, fieldName, fieldValue, sortFieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var pipeline, currN, _a, _b, match, documents, index, gteIndex, lteIndex, predecessorSortId, successorSortId, newSortId, documentsCountWithSameSortId, documentsWithSameSortId, _i, documentsWithSameSortId_1, document_1;
            var _c, _d, _e, _f, _g, _h, _j, _k;
            return __generator(this, function (_l) {
                switch (_l.label) {
                    case 0:
                        console.time("Total time took to update orderId: ".concat(objectId));
                        pipeline = [];
                        _b = (_a = Math).round;
                        return [4 /*yield*/, model.find({}).count().exec()];
                    case 1:
                        currN = _b.apply(_a, [(_l.sent()) / noOfDividePartsForSearching]);
                        match = { $and: (_c = {}, _c[sortFieldName] = { $ne: null }, _c) };
                        _l.label = 2;
                    case 2:
                        if (!true) return [3 /*break*/, 5];
                        return [4 /*yield*/, model.aggregate([
                                { $match: match },
                                {
                                    $setWindowFields: {
                                        sortBy: (_d = {}, _d[sortFieldName] = 1, _d),
                                        output: {
                                            index: { $rank: {} },
                                        },
                                    },
                                },
                                {
                                    $match: {
                                        $expr: {
                                            $eq: [{ $mod: ['$index', currN] }, 0],
                                        },
                                    },
                                },
                                { $project: (_e = {}, _e[fieldName] = 1, _e[sortFieldName] = 1, _e) },
                            ])];
                    case 3:
                        documents = _l.sent();
                        if (currN < noOfDividePartsForSearching) {
                            return [3 /*break*/, 5];
                        }
                        return [4 /*yield*/, getMatchForAggregate(documents, fieldName, fieldValue, sortFieldName)];
                    case 4:
                        match = _l.sent();
                        currN = Math.round(currN / noOfDividePartsForSearching);
                        return [3 /*break*/, 2];
                    case 5:
                        index = documentsBinarySearch(documents, fieldName, fieldValue);
                        gteIndex = index - 1;
                        lteIndex = index;
                        predecessorSortId = documents[gteIndex][sortFieldName];
                        successorSortId = documents[lteIndex][sortFieldName];
                        newSortId = getAverageSortId(predecessorSortId, successorSortId);
                        return [4 /*yield*/, model.updateOne({ _id: objectId }, { $set: (_f = {}, _f[sortFieldName] = newSortId.toString(), _f) })];
                    case 6:
                        _l.sent();
                        return [4 /*yield*/, model
                                .find((_g = {}, _g[sortFieldName] = newSortId.toString(), _g))
                                .count()
                                .exec()];
                    case 7:
                        documentsCountWithSameSortId = _l.sent();
                        if (!(documentsCountWithSameSortId > 1)) return [3 /*break*/, 12];
                        return [4 /*yield*/, model
                                .find((_h = {}, _h[sortFieldName] = newSortId.toString(), _h), (_j = { _id: 1 }, _j[fieldName] = 1, _j))
                                .exec()];
                    case 8:
                        documentsWithSameSortId = _l.sent();
                        console.log("mongoose-sort-encrypted-field -> Got collions, retrying... ".concat(documentsWithSameSortId));
                        _i = 0, documentsWithSameSortId_1 = documentsWithSameSortId;
                        _l.label = 9;
                    case 9:
                        if (!(_i < documentsWithSameSortId_1.length)) return [3 /*break*/, 12];
                        document_1 = documentsWithSameSortId_1[_i];
                        // Retrigering sortId generation due to collion
                        return [4 /*yield*/, model.updateOne({ _id: document_1._id }, { $set: (_k = {}, _k[fieldName] = document_1[fieldName], _k) })];
                    case 10:
                        // Retrigering sortId generation due to collion
                        _l.sent();
                        _l.label = 11;
                    case 11:
                        _i++;
                        return [3 /*break*/, 9];
                    case 12:
                        console.timeEnd("Total time took to update orderId: ".concat(objectId));
                        return [2 /*return*/];
                }
            });
        });
    }
    function updateSortFieldsForUpdateOne(filter, model, fieldName, fieldValue, sortFieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var document;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findOne(filter, { _id: 1 }).exec()];
                    case 1:
                        document = _a.sent();
                        if (!document) return [3 /*break*/, 3];
                        return [4 /*yield*/, updateSortFieldsForDocument(document._id, model, fieldName, fieldValue, sortFieldName)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    function updateSortFieldsForUpdateMany(filter, model, fieldName, fieldValue, sortFieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var documents, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find(filter, { _id: 1 }).exec()];
                    case 1:
                        documents = _a.sent();
                        if (!(documents && documents.length > 0)) return [3 /*break*/, 5];
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < documents.length)) return [3 /*break*/, 5];
                        return [4 /*yield*/, updateSortFieldsForDocument(documents[i]._id, model, fieldName, fieldValue, sortFieldName)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        i += 1;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
    for (var _i = 0, _d = Object.entries(schema.paths); _i < _d.length; _i++) {
        var _e = _d[_i], fieldName = _e[0], field = _e[1];
        if (field.options.sortFieldName) {
            sortFields[fieldName] = field.options.sortFieldName;
            decrypters[fieldName] = field.options.get;
            schema.add((_a = {},
                _a[field.options.sortFieldName] = {
                    type: String,
                    default: null,
                },
                _a));
        }
    }
    options.sortFields = sortFields;
    options.decrypters = decrypters;
    schema.post('save', function (doc, next) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, _b, fieldName, sortFieldName;
            return __generator(this, function (_c) {
                for (_i = 0, _a = Object.entries(sortFields); _i < _a.length; _i++) {
                    _b = _a[_i], fieldName = _b[0], sortFieldName = _b[1];
                    updateSortFieldsForDocument(doc._id, this.constructor, fieldName, doc[fieldName], sortFieldName);
                }
                next();
                return [2 /*return*/];
            });
        });
    });
    schema.post('updateOne', function (res, next) {
        var update = this.getUpdate();
        for (var _i = 0, _a = Object.entries(sortFields); _i < _a.length; _i++) {
            var _b = _a[_i], fieldName = _b[0], sortFieldName = _b[1];
            if (update.$set && update.$set[sortFieldName]) {
                // Bypass middleware internal call for updating any sortFieldName field
                break;
            }
            if (update.$set && update.$set[fieldName]) {
                updateSortFieldsForUpdateOne(this.getFilter(), this.constructor, fieldName, update.$set[fieldName], sortFieldName);
            }
        }
        next();
    });
    schema.post('updateMany', function (res, next) {
        var update = this.getUpdate();
        for (var _i = 0, _a = Object.keys(sortFields); _i < _a.length; _i++) {
            var fieldName = _a[_i];
            var sortFieldName = sortFields[fieldName];
            if (update.$set && update.$set[sortFieldName]) {
                // Bypass middleware internal call for updating any sortFieldName field
                break;
            }
            if (update.$set && update.$set[fieldName]) {
                updateSortFieldsForUpdateMany(this.getFilter(), this.constructor, fieldName, update.$set[fieldName], sortFieldName);
            }
        }
        next();
    });
}
function evaluateMissedSortFields(model) {
    return __awaiter(this, void 0, void 0, function () {
        var pluginOptions, _i, _a, fieldName, sortFieldName, documents, _b, documents_1, document_2;
        var _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    pluginOptions = model.schema.plugins.find(function (plugin) { return plugin.fn.name == 'sortEncryptedFields'; });
                    if (!pluginOptions) {
                        throw 'Plugin is not enabled on this model, Try ModelSchema.plugin(sortEncryptedFields), brefore creating Model.';
                    }
                    _i = 0, _a = Object.keys(pluginOptions.sortFields);
                    _e.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 7];
                    fieldName = _a[_i];
                    sortFieldName = pluginOptions.sortFields[fieldName];
                    return [4 /*yield*/, model.find((_c = {}, _c[sortFieldName] = { $eq: null }, _c))];
                case 2:
                    documents = _e.sent();
                    _b = 0, documents_1 = documents;
                    _e.label = 3;
                case 3:
                    if (!(_b < documents_1.length)) return [3 /*break*/, 6];
                    document_2 = documents_1[_b];
                    // Retrigering sortId generation
                    return [4 /*yield*/, model.updateOne({ _id: document_2._id }, { $set: (_d = {}, _d[fieldName] = document_2[fieldName], _d) })];
                case 4:
                    // Retrigering sortId generation
                    _e.sent();
                    _e.label = 5;
                case 5:
                    _b++;
                    return [3 /*break*/, 3];
                case 6:
                    _i++;
                    return [3 /*break*/, 1];
                case 7: return [2 /*return*/];
            }
        });
    });
}
module.exports = { sortEncryptedFields: sortEncryptedFields, evaluateMissedSortFields: evaluateMissedSortFields };
